package edu.kit.iks.main;

import edu.kit.iks.main.crypts.Key;
import edu.kit.iks.main.crypts.SKE;

public final class GarbledNBitANDCircuitLinear {
	
	
	private GarbledANDGate gates[];
	
	//@ private ghost Key[] ghost_keys_in_0;
	//@ private ghost Key[] ghost_keys_in_1;
	//@ private ghost Key ghost_out0;
	//@ private ghost Key ghost_out1;
	
	
	/*@ private invariant
	  @ gates != null && gates.length >= 1 &&
	  @ gates.length == ghost_keys_in_0.length - 1 &&
	  @
	  @ ghost_keys_in_0 != null && ghost_keys_in_1 != null && 
	  @ ghost_keys_in_0.length == ghost_keys_in_1.length &&
	  @  
	  @ (\forall int i; 0 <= i && i < gates.length; gates[i] != null) &&
	  @ (\forall int i; 0 <= i && i < gates.length; gates[i].\inv) &&
	  @ (\forall int i; 0 <= i && i < gates.length; gates[i].ghost_key_right_0 == ghost_keys_in_0[i+1]) &&
	  @ (\forall int i; 0 <= i && i < gates.length; gates[i].ghost_key_right_1 == ghost_keys_in_1[i+1]) &&
	  @ gates[0].ghost_key_left_0 == ghost_keys_in_0[0] &&
	  @ gates[0].ghost_key_left_1 == ghost_keys_in_1[0] &&
	  @ (\forall int i; 1 <= i && i < gates.length; gates[i].ghost_key_left_0 == gates[i-1].ghost_key_out_0) &&
	  @ (\forall int i; 1 <= i && i < gates.length; gates[i].ghost_key_left_1 == gates[i-1].ghost_key_out_1) &&
	  @ (\forall int i; 0 <= i && i < gates.length; gates[i].ghost_key_out_0 != null) &&
	  @ (\forall int i; 0 <= i && i < gates.length; gates[i].ghost_key_out_1 != null) &&
	  @ gates[gates.length - 1].ghost_key_out_0 == ghost_out0 &&
	  @ gates[gates.length - 1].ghost_key_out_1 == ghost_out1;
	  */
	
	
	/*@ public normal_behaviour
	  @ requires in0.length > 1 && in0.length == in1.length && 
	  @			 (\forall int i; 0 <= i && i < in0.length - 1; in0[i] != in0[i+1]) &&
	  @			 (\forall int i; 0 <= i && i < in0.length - 1; in0[i].ident != in0[i+1].ident) &&
	  @			 (\forall int i; 0 <= i && i < in1.length - 1; in1[i] != in1[i+1]) &&
	  @			 (\forall int i; 0 <= i && i < in1.length - 1; in1[i].ident != in1[i+1].ident) &&
	  @			 (\forall int i; 0 <= i && i < in0.length - 1; in0[i] != in1[i+1]) &&
  	  @			 (\forall int i; 0 <= i && i < in0.length - 1; in0[i].ident != in1[i+1].ident) &&
	  @			 (\forall int i; 0 <= i && i < in1.length - 1; in1[i] != in0[i+1]) &&
	  @			 (\forall int i; 0 <= i && i < in1.length - 1; in1[i].ident != in0[i+1].ident) &&
	  @ 		 (\forall int i; 0 <= i && i < in0.length; in0[i] != in1[i]) &&
	  @ 		 (\forall int i; 0 <= i && i < in0.length; in0[i].ident != in1[i].ident) &&	  
	  @			 (\forall int j; 0 <= j && j < in0.length; in0[j] != null) &&
	  @			 (\forall int j; 0 <= j && j < in1.length; in1[j] != null) &&
	  @          (\forall int i; 0 <= i && i < in0.length; in0[i] != out0 && in0[i] != out1) &&
	  @          (\forall int i; 0 <= i && i < in0.length; in0[i].ident != out0.ident && in0[i].ident != out1.ident) &&
	  @          (\forall int i; 0 <= i && i < in1.length; in1[i] != out0 && in1[i] != out1) &&
	  @          (\forall int i; 0 <= i && i < in1.length; in1[i].ident != out0.ident && in1[i].ident != out1.ident) &&
	  @			 in0 != in1 &&
	  @          out0 != out1 && out0.ident != out1.ident 
	  @			 && SKE.mixCounter + in0.length < SKE.randomMix.length && 0 <= SKE.mixCounter
	  @			 && SKE.randomMix != null
	  @ 		 && (SKE.counter + 10 * in0.length) < SKE.randoms.length && 0 <= SKE.counter
	  @			 && SKE.randoms != null 
	  @			 && (\forall int i; i < SKE.randoms.length && SKE.counter <= i; 
	  @					(\forall int j; 0 <= j && j < in0.length; in0[j].ident != SKE.randoms[i]))
	  @			 && (\forall int i; i < SKE.randoms.length && SKE.counter <= i; 
	  @					(\forall int j; 0 <= j && j < in1.length; in1[j].ident != SKE.randoms[i]))
	  @			 && (\forall int i; i < SKE.randoms.length && SKE.counter <= i; 
	  @					out0.ident != SKE.randoms[i])
	  @			 && (\forall int i; i < SKE.randoms.length && SKE.counter <= i; 
	  @					out1.ident != SKE.randoms[i]);
	  @ ensures 
	  @ 	(\forall int i; 0 <= i && i < in0.length; ghost_keys_in_0[i].ident == \old(in0[i].ident))
	  @     && (\forall int i; 0 <= i && i < in1.length; ghost_keys_in_1[i].ident == \old(in1[i].ident));
	  */
	public GarbledNBitANDCircuitLinear(Key[] in0, Key[] in1, Key out0, Key out1) {
		//@ set ghost_keys_in_0 = in0;
		//@ set ghost_keys_in_1 = in1;
		//@ set ghost_out0 = out0;
		//@ set ghost_out1 = out1;
		
		gates = new GarbledANDGate[in0.length - 1];
		
		// set the first gate
		if (in0.length == 2) {
			addGate(0, in0[0], in1[0], in0[1], in1[1], out0, out1);
			finalOut0 = out0;
			finalOut1 = out1;
		} else if (in0.length == 3) {
			Key next_left0 = SKE.GenKey();
			Key next_left1 = SKE.GenKey();	
			
			addGate(0, in0[0], in1[0], in0[1], in1[1], next_left0, next_left1);
		
			addGate(gates.length-1, next_left0, next_left1, in0[in0.length-1], in1[in1.length-1], out0, out1);
			finalOut0 = out0;
			finalOut1 = out1;
		} else {
			Key next_left0 = SKE.GenKey();
			Key next_left1 = SKE.GenKey();	
			
			addGate(0, in0[0], in1[0], in0[1], in1[1], next_left0, next_left1);
		
			setMiddleGates(next_left0, next_left1, in0, in1);
		
 
			addGate(gates.length-1, finalOut0, finalOut1, in0[in0.length-1], in1[in1.length-1], out0, out1);
		}
	}
	

	Key finalOut0;
	Key finalOut1;
	
	/*@ public normal_behaviour
	  @ requires 
	  @			 (\forall int i; 0 <= i && i < in0.length - 1; in0[i] != in0[i+1]) &&
	  @			 (\forall int i; 0 <= i && i < in0.length - 1; in0[i].ident != in0[i+1].ident) &&
	  @			 (\forall int i; 0 <= i && i < in1.length - 1; in1[i] != in1[i+1]) &&
	  @			 (\forall int i; 0 <= i && i < in1.length - 1; in1[i].ident != in1[i+1].ident) &&
	  @			 (\forall int i; 0 <= i && i < in0.length - 1; in0[i] != in1[i+1]) &&
	  @			 (\forall int i; 0 <= i && i < in0.length - 1; in0[i].ident != in1[i+1].ident) &&
	  @			 (\forall int i; 0 <= i && i < in1.length - 1; in1[i] != in0[i+1]) &&
	  @			 (\forall int i; 0 <= i && i < in1.length - 1; in1[i].ident != in0[i+1].ident) &&
	  @ 		 (\forall int i; 0 <= i && i < in0.length; in0[i] != in1[i]) &&
	  @ 		 (\forall int i; 0 <= i && i < in0.length; in0[i].ident != in1[i].ident) &&
	  @			 (\forall int j; 0 <= j && j < in0.length; in0[j] != null) &&
	  @			 (\forall int j; 0 <= j && j < in1.length; in1[j] != null) &&
	  @ 		 next_left0 != next_left1 && next_left0.ident != next_left1.ident &&
	  @ 		 next_left0 != in0[2] && next_left0 != in1[2] &&
	  @ 		 next_left0.ident != in0[2].ident && next_left0.ident != in1[2].ident &&
	  @ 		 next_left1 != in0[2] && next_left1 != in1[2] &&
	  @ 		 next_left1.ident != in0[2].ident && next_left1.ident != in1[2].ident &&
	  @ 		 next_left0 != null && next_left1 != null &&
	  @			 in0.length > 3 &&
	  @			 in0 != in1 && in0 != gates && in1 != gates && gates.length + 1 == in0.length &&
	  @			 in0.length == in1.length &&
	  @			 gates != null &&
	  @			 \typeof(gates) == \type(GarbledANDGate[]) &&
	  @			 gates[0] != null &&
	  @			 gates[0].ghost_key_left_0 == in0[0] && gates[0].ghost_key_left_1 == in1[0] &&
	  @			 gates[0].ghost_key_left_0.ident == in0[0].ident && gates[0].ghost_key_left_1.ident == in1[0].ident &&
	  @			 gates[0].ghost_key_left_0 != gates[0].ghost_key_left_1 &&
	  @			 gates[0].ghost_key_left_0.ident != gates[0].ghost_key_left_1.ident &&
	  @			 gates[0].ghost_key_right_0 == in0[1] && gates[0].ghost_key_right_1 == in1[1] &&
	  @			 gates[0].ghost_key_right_0.ident == in0[1].ident && gates[0].ghost_key_right_1.ident == in1[1].ident &&
	  @			 gates[0].ghost_key_out_0 == next_left0 && gates[0].ghost_key_out_1 == next_left1 &&
	  @			 gates[0].ghost_key_out_0.ident == next_left0.ident && gates[0].ghost_key_out_1.ident == next_left1.ident &&
	  @			 gates[0].\inv
	  @			 && SKE.mixCounter + gates.length - 1 < SKE.randomMix.length && 0 <= SKE.mixCounter
	  @			 && SKE.randomMix != null
	  @ 		 && (SKE.counter + 10 * gates.length) - 1 < SKE.randoms.length && 10 <= SKE.counter
	  @			 && SKE.randoms != null 
	  @			 && (\forall int i; i < SKE.randoms.length && SKE.counter <= i; 
	  @					(\forall int j; 0 <= j && j < in0.length; in0[j].ident != SKE.randoms[i]))
	  @			 && (\forall int i; i < SKE.randoms.length && SKE.counter <= i; 
	  @					(\forall int j; 0 <= j && j < in1.length; in1[j].ident != SKE.randoms[i]))
	  @			 && next_left0.ident == SKE.randoms[SKE.counter -10] &&
	  @ 		    next_left1.ident == SKE.randoms[SKE.counter -9]; 
	  @ ensures 
	  @ 	gates != in0 &&
      @ 	gates != in1 &&
	  @ 	gates.length + 1 == in0.length &&
	  @ 	gates.length + 1 == in1.length &&
	  @		finalOut0 != null && \fresh(finalOut0) && finalOut0 == gates[gates.length-2].ghost_key_out_0 &&
	  @		finalOut1 != null && \fresh(finalOut1) && finalOut1 == gates[gates.length-2].ghost_key_out_1 &&
	  @		finalOut0.ident == gates[gates.length-2].ghost_key_out_0.ident &&
	  @		finalOut1.ident == gates[gates.length-2].ghost_key_out_1.ident &&
	  @		finalOut0.ident == SKE.randoms[SKE.counter -10] &&
	  @ 	finalOut1.ident == SKE.randoms[SKE.counter -9] &&
	  @		finalOut0 != finalOut1 &&
	  @		finalOut0.ident != finalOut1.ident &&
	  @ 	\old(next_left0) == gates[0].ghost_key_out_0 && \old(next_left1) == gates[0].ghost_key_out_1 &&
	  @ 	\old(next_left0).ident == gates[0].ghost_key_out_0.ident && \old(next_left1.ident) == gates[0].ghost_key_out_1.ident &&
	  @ 	gates[0].ghost_key_left_0 == in0[0] && gates[0].ghost_key_left_1 == in1[0] &&
	  @ 	gates[0].ghost_key_left_0.ident == in0[0].ident && gates[0].ghost_key_left_1.ident == in1[0].ident &&
	  @ 	(\forall int j; 0 <= j && j < in0.length; 
	  @			(in0[j] != null) && (in1[j] != null) && (in0[j] != in1[j]) && (in0[j].ident != in1[j].ident)) &&
	  @ 	(\forall int j; 0 <= j && j < gates.length-1; 
	  @			(gates[j].ghost_key_out_1 != gates[j].ghost_key_out_0) && (gates[j] != null) && 
	  @			(gates[j].ghost_key_right_0 == in0[j+1]) &&
	  @			(gates[j].ghost_key_right_1 == in1[j+1]) &&
	  @			(gates[j].ghost_key_out_1.ident != gates[j].ghost_key_out_0.ident) &&  
	  @			(gates[j].ghost_key_right_0.ident == in0[j+1].ident) &&
	  @			(gates[j].ghost_key_right_1.ident == in1[j+1].ident)) &&
	  @		(\forall int j; 1 <= j && j < gates.length-1;
	  @			(gates[j].ghost_key_left_0 == gates[j-1].ghost_key_out_0) &&
	  @			(gates[j].ghost_key_left_1 == gates[j-1].ghost_key_out_1) &&
	  @			(gates[j].ghost_key_left_0.ident == gates[j-1].ghost_key_out_0.ident) &&
	  @			(gates[j].ghost_key_left_1.ident == gates[j-1].ghost_key_out_1.ident)) &&
	  @		(\forall int j; 1 <= j && j < gates.length-1; \fresh(gates[j]) &&
	  @			\fresh(gates[j].ghost_key_out_0) && \fresh(gates[j].ghost_key_out_1)) &&
	  @		(\forall int j; 0 <= j && j < gates.length-1; gates[j].\inv) &&
	  @		(\forall int j; 0 <= j && j < gates.length-1; gates[j].ghost_key_left_0 != null &&
	  @			gates[j].ghost_key_left_1 != null) &&
	  @		\old(gates[0]) == gates[0] &&
	  @		SKE.mixCounter == \old(SKE.mixCounter) + gates.length - 2 &&
	  @		SKE.counter == \old(SKE.counter) + (10 * (gates.length - 2));	
	  @
	  @   assignable gates[*], finalOut0, finalOut1, SKE.counter, SKE.mixCounter;
	 */
	private void /*@ helper */ setMiddleGates(Key next_left0, Key next_left1, Key[] in0, Key[] in1) {
		//@ ghost Key oldnext0;
		//@ ghost Key oldnext1;
		//@ ghost GarbledANDGate oldGate;
		
		//@ set oldnext0 = gates[0].ghost_key_out_0;
		//@ set oldnext1 = gates[0].ghost_key_out_1;
		//@ set oldGate = gates[0];
		
		Key newOut0 = null;
		Key newOut1 = null;
		
		/*@ loop_invariant
		  @ gates != in0 &&
		  @ gates != in1 &&
		  @ oldnext0 == gates[0].ghost_key_out_0 &&
		  @ oldnext1 == gates[0].ghost_key_out_1 &&
		  @ oldnext0.ident == gates[0].ghost_key_out_0.ident &&
		  @ oldnext1.ident == gates[0].ghost_key_out_1.ident &&
		  @ oldGate == gates[0] &&
		  @ gates[i-1] != null &&
		  @ 1 <= i && i <= gates.length -1 &&
		  @ gates.length + 1 == in0.length &&
		  @ gates.length + 1 == in1.length &&
		  @ next_left0 == gates[i-1].ghost_key_out_0 && next_left1 == gates[i-1].ghost_key_out_1 &&
		  @ next_left0.ident == gates[i-1].ghost_key_out_0.ident && next_left1.ident == gates[i-1].ghost_key_out_1.ident &&
		  @ next_left0 != next_left1 &&
		  @ next_left0.ident != next_left1.ident &&
		  @ next_left0 != in0[i+1] && next_left0 != in1[i+1] &&
		  @ next_left0.ident != in0[i+1].ident && next_left0.ident != in1[i+1].ident &&
		  @ next_left1 != in0[i+1] && next_left1 != in1[i+1] &&
		  @ next_left1.ident != in0[i+1].ident && next_left1.ident != in1[i+1].ident &&
		  @ next_left0 != null && next_left1 != null &&
		  @ gates[0].ghost_key_left_0 == in0[0] && gates[0].ghost_key_left_1 == in1[0] &&
		  @ gates[0].ghost_key_left_0.ident == in0[0].ident && gates[0].ghost_key_left_1.ident == in1[0].ident &&
		  @ gates[0] != null &&
		  @ !\fresh(gates[0]) &&
		  @ (\forall int j; 0 <= j && j < in0.length; 
		  @			(in0[j] != null) && (in1[j] != null) && (in0[j] != in1[j]) && (in0[j].ident != in1[j].ident)) &&
		  @ (\forall int j; 0 <= j && j < i; gates[j] != null) &&
		  @ (\forall int j; 1 <= j && j < i; \fresh(gates[j])) &&
		  @ (\forall int j; 0 <= j && j < i; 
		  @			(gates[j].ghost_key_out_1 != gates[j].ghost_key_out_0) && (gates[j] != null) && 
		  @			(gates[j].ghost_key_right_0 == in0[j+1]) &&
		  @			(gates[j].ghost_key_right_1 == in1[j+1]) &&
		  @			(gates[j].ghost_key_out_1.ident != gates[j].ghost_key_out_0.ident) &&  
		  @			(gates[j].ghost_key_right_0 == in0[j+1]) &&
		  @			(gates[j].ghost_key_right_0.ident == in0[j+1].ident) &&
		  @			(gates[j].ghost_key_right_1 == in1[j+1]) &&
		  @			(gates[j].ghost_key_right_1.ident == in1[j+1].ident)) &&
		  @ (\forall int j; 1 <= j && j < i;
		  @			(gates[j].ghost_key_left_0 == gates[j-1].ghost_key_out_0) &&
		  @			(gates[j].ghost_key_left_1 == gates[j-1].ghost_key_out_1) &&
		  @			(gates[j].ghost_key_left_0.ident == gates[j-1].ghost_key_out_0.ident) &&
		  @			(gates[j].ghost_key_left_1.ident == gates[j-1].ghost_key_out_1.ident)) &&
		  @ (\forall int j; 1 <= j && j < i; \fresh(gates[j].ghost_key_out_0) && \fresh(gates[j].ghost_key_out_1)) &&
		  @ (\forall int j; 0 <= j && j < i; gates[j].ghost_key_left_0 != null && gates[j].ghost_key_left_1 != null) &&
		  @ (\forall int j; 0 <= j && j < i; gates[j].\inv) &&
		  @		(i > 1 ==> (\fresh(next_left0) && \fresh(next_left1))) &&
		  @	SKE.mixCounter == \old(SKE.mixCounter) + i - 1 &&
	      @	SKE.counter == \old(SKE.counter) + (10 * (i - 1)) &&
	      @	SKE.randomMix != null && SKE.randoms != null &&
	      @ next_left0.ident == SKE.randoms[SKE.counter -10] &&
	      @ next_left1.ident == SKE.randoms[SKE.counter -9];		  
		  @
		  @ assignable gates[*], next_left0, next_left1, SKE.mixCounter, SKE.counter;
		  @ decreases gates.length - 1 - i;
		 */
		for (int i = 1; i < gates.length - 1; i++) {
			newOut0 = SKE.GenKey();
			newOut1 = SKE.GenKey();
			
			/*@ requires (\forall int j; 0 <= j && j < SKE.counter-1; SKE.randoms[j] != SKE.randoms[SKE.counter-1]) &&
			  @		(\forall int j; 0 <= j && j < SKE.counter-2; SKE.randoms[j] != SKE.randoms[SKE.counter-2]) &&
			  @		(\forall int j; j < SKE.randoms.length && SKE.counter-2 <= j; 
	  		  @			in0[i+1].ident != SKE.randoms[j]) &&
	  		  @		(\forall int j; j < SKE.randoms.length && SKE.counter-2 <= j; 
	  		  @			in1[i+1].ident != SKE.randoms[j]) &&
	  		  @		(\forall int j; 0 <= j && j < i; gates[j].\inv);
			  @ ensures newOut0.ident != newOut1.ident &&
			  @ 	next_left0.ident != next_left1.ident &&
			  @		in0[i+1].ident != in1[i+1].ident &&
			  @ 	next_left0.ident != newOut0.ident &&
			  @		next_left1.ident != newOut0.ident &&
			  @ 	next_left0.ident != newOut1.ident &&
			  @		next_left1.ident != newOut1.ident &&
			  @ 	next_left0.ident != in0[i+1].ident &&
			  @		next_left1.ident != in0[i+1].ident &&
			  @ 	next_left0.ident != in1[i+1].ident &&
			  @		next_left1.ident != in1[i+1].ident &&
			  @ 	newOut0.ident != in0[i+1].ident &&
			  @		newOut1.ident != in0[i+1].ident &&
			  @ 	newOut0.ident != in1[i+1].ident &&
			  @		newOut1.ident != in1[i+1].ident &&
			  @ (\forall int j; 0 <= j && j < i; gates[j].\inv);
			  @ assignable \less_than_nothing;
			  @ signals_only \nothing;
			 */
			{int lemma1;}
			
			addGate(i, next_left0, next_left1, in0[i+1], in1[i+1], newOut0, newOut1);
			
			next_left0 = newOut0;
			next_left1 = newOut1;
		}
		
		finalOut0 = next_left0;
		finalOut1 = next_left1;
	}
	

	/*@ public normal_behaviour 
	  @ requires    (left0 != left1)  
	  @          && (left0 != right0) && (left0 != right1)
	  @          && (left0 != out0) && (left0 != out1)
	  @          && (left1 != right0) && (left1 != right1)
	  @          && (left1 != out0) && (left1 != out1)
	  @          && (right0 != right1) 
	  @          && (right0 != out0) && (right0 != out1)
	  @          && (right1 != out0) && (right1 != out1)
	  @          && (out0 != out1) && (left0.ident != left1.ident)  
	  @          && (left0.ident != right0.ident) && (left0.ident != right1.ident)
	  @          && (left0.ident != out0.ident) && (left0.ident != out1.ident)
	  @          && (left1.ident != right0.ident) && (left1.ident != right1.ident)
	  @          && (left1.ident != out0.ident) && (left1.ident != out1.ident)
	  @          && (right0.ident != right1.ident) 
	  @          && (right0.ident != out0.ident) && (right0.ident != out1.ident)
	  @          && (right1.ident != out0.ident) && (right1.ident != out1.ident)
	  @          && (out0.ident != out1.ident) && gates != null 
	  @			 && 0 <= index && index < gates.length 
	  @			 && \typeof(gates) == \type(GarbledANDGate[]) 
	  @			 && SKE.mixCounter < SKE.randomMix.length && 0 <= SKE.mixCounter
	  @			 && SKE.randomMix != null
	  @ 		 && SKE.counter < SKE.randoms.length-8 && 0 <= SKE.counter
	  @			 && SKE.randoms != null;
	  @ ensures gates[index].ghost_key_left_0 == left0 &&
	  @         gates[index].ghost_key_left_1 == left1 &&
	  @         gates[index].ghost_key_right_0 == right0 &&
	  @         gates[index].ghost_key_right_1 == right1 &&
	  @         gates[index].ghost_key_out_0 == out0 &&
	  @         gates[index].ghost_key_out_1 == out1 &&
	  @			gates[index].ghost_key_left_0.ident == left0.ident &&
	  @         gates[index].ghost_key_left_1.ident == left1.ident &&
	  @         gates[index].ghost_key_right_0.ident == right0.ident &&
	  @         gates[index].ghost_key_right_1.ident == right1.ident &&
	  @         gates[index].ghost_key_out_0.ident == out0.ident &&
	  @         gates[index].ghost_key_out_1.ident == out1.ident &&
	  @			\fresh(gates[index]) &&
	  @			gates[index] != null &&
	  @			gates[index].\inv &&
	  @			SKE.mixCounter == \old(SKE.mixCounter) + 1 &&
	  @			SKE.counter == \old(SKE.counter) + 8;   
	  @ assignable gates[index], SKE.counter, SKE.mixCounter;
	  @*/
	private /*@ helper */ void addGate(int index, Key left0, Key left1, Key right0, Key right1, Key out0, Key out1) {
		gates[index] = new GarbledANDGate(left0, left1, right0, right1, out0, out1);
	}
	
	
	
	
	/*@ public normal_behaviour
	  @ requires in.length == ghost_keys_in_0.length &&
	  @			 in != null &&
	  @			 (\forall int i; 0 <= i && i < in.length; in[i] != null) &&
	  @          (\forall int i; 0 <= i && i < in.length; in[i].ident == ghost_keys_in_0[i].ident || in[i].ident == ghost_keys_in_1[i].ident);
	  @ ensures ((!(\forall int i; 0 <= i && i < in.length; in[i].ident == ghost_keys_in_1[i].ident)) ==> \result.ident == ghost_out0.ident) &&
	  @         ((\forall int i; 0 <= i && i < in.length; in[i].ident == ghost_keys_in_1[i].ident) ==> \result.ident == ghost_out1.ident);
	  @	assignable \nothing; 
	 */	
	public Key evaluate(Key[] in) {
		
		
		Key key_left = gates[0].evaluate(in[0], in[1]);
		
		
		
		/*@ loop_invariant
		  @ 1 <= i && i <= gates.length &&
		  @ key_left != null && \fresh(key_left) &&
		  @ ((!(\forall int j; 0 <= j && j < i+1; in[j].ident == ghost_keys_in_1[j].ident)) ==> key_left.ident == gates[i-1].ghost_key_out_0.ident) &&
	      @ ((\forall int j; 0 <= j && j < i+1; in[j].ident == ghost_keys_in_1[j].ident) ==> key_left.ident == gates[i-1].ghost_key_out_1.ident) &&
	      @ (\forall int j; 0 <= j && j < gates.length; gates[j].\inv);
		  @ assignable \nothing;
		  @ decreases gates.length - i;
		  */
		for(int i = 1; i < gates.length; i++) {
			key_left = gates[i].evaluate(key_left, in[i + 1]);
			
		}
		return key_left;
	}	
}