package edu.kit.iks.main;

import edu.kit.iks.main.crypts.Cipher;
import edu.kit.iks.main.crypts.Key;
import edu.kit.iks.main.crypts.SKE;

public final class GarbledXORGate extends GarbledGate {
		
	private Cipher evaluation_table[];
	
	//@ public ghost Key ghost_key_left_0;
	//@ public ghost Key ghost_key_left_1;
	//@ public ghost Key ghost_key_right_0;
	//@ public ghost Key ghost_key_right_1;
	//@ public ghost Key ghost_key_out_0;
	//@ public ghost Key ghost_key_out_1;
	
	/*@ public invariant
	  @ \typeof(ghost_key_out_0) == Key &&
	  @	 \typeof(ghost_key_out_1) == Key;
	 */
	
	// Invariant: All keys are pairwise distinct and their idents differnet.
	/*@ private invariant     (ghost_key_left_0 != null) 
	  @                   && (ghost_key_left_0.ident != ghost_key_left_1.ident)  
	  @                   && (ghost_key_left_0.ident != ghost_key_right_0.ident) && (ghost_key_left_0.ident != ghost_key_right_1.ident)
	  @                   && (ghost_key_left_0.ident != ghost_key_out_0.ident) && (ghost_key_left_0.ident != ghost_key_out_1.ident)
	  @                   && (ghost_key_left_1 != null)
	  @                   && (ghost_key_left_1.ident != ghost_key_right_0.ident) && (ghost_key_left_1.ident != ghost_key_right_1.ident)
	  @                   && (ghost_key_left_1.ident != ghost_key_out_0.ident) && (ghost_key_left_1.ident != ghost_key_out_1.ident)
	  @                   && (ghost_key_right_0 != null)
	  @                   && (ghost_key_right_0.ident != ghost_key_right_1.ident) 
	  @                   && (ghost_key_right_0.ident != ghost_key_out_0.ident) && (ghost_key_right_0.ident != ghost_key_out_1.ident)
	  @                   && (ghost_key_right_1 != null)
	  @                   && (ghost_key_right_1.ident != ghost_key_out_0.ident) && (ghost_key_right_1.ident != ghost_key_out_1.ident)
	  @                   && (ghost_key_out_0 != null)
	  @                   && (ghost_key_out_0.ident != ghost_key_out_1.ident)
	  @                   && (ghost_key_out_1 != null); 
	  */
	
	// Invariant: All keys are pairwise distinct.
	/*@ private invariant (ghost_key_left_0 != ghost_key_left_1)  
	  @                   && (ghost_key_left_0 != ghost_key_right_0) && (ghost_key_left_0 != ghost_key_right_1)
	  @                   && (ghost_key_left_0 != ghost_key_out_0) && (ghost_key_left_0 != ghost_key_out_1)
	  @                   && (ghost_key_left_1 != ghost_key_right_0) && (ghost_key_left_1 != ghost_key_right_1)
	  @                   && (ghost_key_left_1 != ghost_key_out_0) && (ghost_key_left_1 != ghost_key_out_1)
	  @                   && (ghost_key_right_0 != ghost_key_right_1) 
	  @                   && (ghost_key_right_0 != ghost_key_out_0) && (ghost_key_right_0 != ghost_key_out_1)
	  @                   && (ghost_key_right_1 != ghost_key_out_0) && (ghost_key_right_1 != ghost_key_out_1)
	  @                   && (ghost_key_out_0 != ghost_key_out_1); 
	  */
	
	//@ private invariant this.evaluation_table != null;	
	//@ private invariant this.evaluation_table.length == 4;
	
	
	//@ private ghost int chipherindex0; 
	//@ private ghost int chipherindex1;
	//@ private ghost int chipherindex2;
	//@ private ghost int chipherindex3;
	
	/*@ private invariant chipherindex0 != chipherindex1 && chipherindex0 != chipherindex2 &&
	  @			chipherindex0 != chipherindex3 && chipherindex1 != chipherindex2 &&
	  @			chipherindex1 != chipherindex3 && chipherindex2 != chipherindex3 &&
	  @			(chipherindex0 == 0 || chipherindex0 == 1 || chipherindex0 == 2 || chipherindex0 == 3) &&
	  @			(chipherindex1 == 0 || chipherindex1 == 1 || chipherindex1 == 2 || chipherindex1 == 3) &&
	  @			(chipherindex2 == 0 || chipherindex2 == 1 || chipherindex2 == 2 || chipherindex2 == 3) &&
	  @			(chipherindex3 == 0 || chipherindex3 == 1 || chipherindex3 == 2 || chipherindex3 == 3);
	 */
	
	//@ private invariant ((Cipher)(this.evaluation_table[0])).\inv;
	//@ private invariant ((Cipher)(this.evaluation_table[1])).\inv;
	//@ private invariant ((Cipher)(this.evaluation_table[2])).\inv;
	//@ private invariant ((Cipher)(this.evaluation_table[3])).\inv;
	
	//@ private invariant ((Cipher)(((Cipher)(this.evaluation_table[0])).message)).\inv;
	//@ private invariant ((Cipher)(((Cipher)(this.evaluation_table[1])).message)).\inv;
	//@ private invariant ((Cipher)(((Cipher)(this.evaluation_table[2])).message)).\inv;
	//@ private invariant ((Cipher)(((Cipher)(this.evaluation_table[3])).message)).\inv;

	//@ private invariant this.evaluation_table[chipherindex0] != null;
	//@ private invariant this.evaluation_table[chipherindex0].key == ghost_key_left_0;
	//@ private invariant this.evaluation_table[chipherindex0].key.ident == ghost_key_left_0.ident;
	//@ private invariant \typeof(this.evaluation_table[chipherindex0].message) == Cipher;
	//@ private invariant ((Cipher)this.evaluation_table[chipherindex0].message).key == ghost_key_right_0;
	//@ private invariant ((Cipher)this.evaluation_table[chipherindex0].message).key.ident == ghost_key_right_0.ident;
	//@ private invariant ((Cipher)this.evaluation_table[chipherindex0].message).message == ghost_key_out_0;
	
	//@ private invariant this.evaluation_table[chipherindex1] != null;
	//@ private invariant this.evaluation_table[chipherindex1].key == ghost_key_left_0;	
	//@ private invariant this.evaluation_table[chipherindex1].key.ident == ghost_key_left_0.ident;	
	//@ private invariant \typeof(this.evaluation_table[chipherindex1].message) == Cipher;
	//@ private invariant ((Cipher)this.evaluation_table[chipherindex1].message).key == ghost_key_right_1;
	//@ private invariant ((Cipher)this.evaluation_table[chipherindex1].message).key.ident == ghost_key_right_1.ident;
	//@ private invariant ((Cipher)this.evaluation_table[chipherindex1].message).message == ghost_key_out_1;
	
	//@ private invariant this.evaluation_table[chipherindex2] != null;
	//@ private invariant this.evaluation_table[chipherindex2].key == ghost_key_left_1;
	//@ private invariant this.evaluation_table[chipherindex2].key.ident == ghost_key_left_1.ident;	
	//@ private invariant \typeof(this.evaluation_table[chipherindex2].message) == Cipher;
	//@ private invariant ((Cipher)this.evaluation_table[chipherindex2].message).key == ghost_key_right_0;
	//@ private invariant ((Cipher)this.evaluation_table[chipherindex2].message).key.ident == ghost_key_right_0.ident;
	//@ private invariant ((Cipher)this.evaluation_table[chipherindex2].message).message == ghost_key_out_1;
	
	//@ private invariant this.evaluation_table[chipherindex3] != null;
	//@ private invariant this.evaluation_table[chipherindex3].key == ghost_key_left_1;
	//@ private invariant this.evaluation_table[chipherindex3].key.ident == ghost_key_left_1.ident;	
	//@ private invariant \typeof(this.evaluation_table[chipherindex3].message) == Cipher;
	//@ private invariant ((Cipher)this.evaluation_table[chipherindex3].message).key == ghost_key_right_1;
	//@ private invariant ((Cipher)this.evaluation_table[chipherindex3].message).key.ident == ghost_key_right_1.ident;
	//@ private invariant ((Cipher)this.evaluation_table[chipherindex3].message).message == ghost_key_out_0;

	/*@ private invariant SKE.randoms != null &&
	  @				SKE.randomMix != null &&
	  @				SKE.randomMix[*] != null;
	 */

	//@ public ghost int initialCounterPos;
	/*@ private invariant evaluation_table[chipherindex0].ident == SKE.randoms[initialCounterPos] &&
	  @			evaluation_table[chipherindex0].message.ident == SKE.randoms[initialCounterPos+1] &&
	  @			evaluation_table[chipherindex1].ident == SKE.randoms[initialCounterPos+2] &&
	  @			evaluation_table[chipherindex1].message.ident == SKE.randoms[initialCounterPos+3] &&
	  @			evaluation_table[chipherindex2].ident == SKE.randoms[initialCounterPos+4] &&
	  @			evaluation_table[chipherindex2].message.ident == SKE.randoms[initialCounterPos+5] &&
	  @			evaluation_table[chipherindex3].ident == SKE.randoms[initialCounterPos+6] &&
	  @			evaluation_table[chipherindex3].message.ident == SKE.randoms[initialCounterPos+7];
	  @
	 */
	
	//How are the cipherindices mixed.
	//@ public ghost int initialMixPos;
	/*@ private invariant chipherindex0 == SKE.randomMix[initialMixPos][0] &&
	  @			chipherindex1 == SKE.randomMix[initialMixPos][1] &&
	  @			chipherindex2 == SKE.randomMix[initialMixPos][2] &&
	  @			chipherindex3 == SKE.randomMix[initialMixPos][3] &&
	  @			SKE.randomMix[initialMixPos] != null &&
	  @			SKE.randomMix[initialMixPos].length == 4 &&
	  @			SKE.randoms != null;
	 */
	
	/*@ accessible \inv: this.*, this.evaluation_table[*], 
	  @ this.evaluation_table[0].*, this.evaluation_table[1].*, 
	  @ this.evaluation_table[2].*, this.evaluation_table[3].*,  
	  @ this.evaluation_table[0].message.*, this.evaluation_table[1].message.*, 
	  @ this.evaluation_table[2].message.*, this.evaluation_table[3].message.*,    
 	  @ this.evaluation_table[0].key.ident, this.evaluation_table[1].key.ident, 
	  @ this.evaluation_table[2].key.ident, this.evaluation_table[3].key.ident, 
	  @ this.evaluation_table[chipherindex0].*, this.evaluation_table[chipherindex1].*, 
	  @ this.evaluation_table[chipherindex2].*, this.evaluation_table[chipherindex3].*,  
	  @ this.evaluation_table[chipherindex0].message.*, this.evaluation_table[chipherindex1].message.*, 
	  @ this.evaluation_table[chipherindex2].message.*, this.evaluation_table[chipherindex3].message.*,    
 	  @ this.evaluation_table[chipherindex0].key.ident, this.evaluation_table[chipherindex1].key.ident, 
	  @ this.evaluation_table[chipherindex2].key.ident, this.evaluation_table[chipherindex3].key.ident, 
	  @ ghost_key_left_0, ghost_key_left_1, ghost_key_right_0, ghost_key_right_1, ghost_key_out_0, ghost_key_out_1,
	  @ ghost_key_left_0.ident, ghost_key_left_1.ident, ghost_key_right_0.ident, ghost_key_right_1.ident, ghost_key_out_0.ident, ghost_key_out_1.ident,
	  @ SKE.randoms, SKE.randoms[*],  	  
	  @ SKE.randomMix, SKE.randomMix[initialMixPos], SKE.randomMix.*, SKE.randomMix[initialMixPos].*, SKE.randomMix[initialMixPos][*]; 
	 */
	
	/*@ public normal_behaviour
	  @ requires    (key_left0.ident != key_left1.ident)  
	  @          && (key_left0.ident != key_right0.ident) && (key_left0.ident != key_right1.ident)
	  @          && (key_left0.ident != key_out0.ident) && (key_left0.ident != key_out1.ident)
	  @          && (key_left1.ident != key_right0.ident) && (key_left1.ident != key_right1.ident)
	  @          && (key_left1.ident != key_out0.ident) && (key_left1.ident != key_out1.ident)
	  @          && (key_right0.ident != key_right1.ident) 
	  @          && (key_right0.ident != key_out0.ident) && (key_right0.ident != key_out1.ident)
	  @          && (key_right1.ident != key_out0.ident) && (key_right1.ident != key_out1.ident)
	  @          && (key_out0.ident != key_out1.ident) 
	  @			 && (key_left0 != key_left1)  
	  @          && (key_left0 != key_right0) && (key_left0 != key_right1)
	  @          && (key_left0 != key_out0) && (key_left0 != key_out1)
	  @          && (key_left1 != key_right0) && (key_left1 != key_right1)
	  @          && (key_left1 != key_out0) && (key_left1 != key_out1)
	  @          && (key_right0 != key_right1) 
	  @          && (key_right0 != key_out0) && (key_right0 != key_out1)
	  @          && (key_right1 != key_out0) && (key_right1 != key_out1)
	  @          && (key_out0 != key_out1) 
	  @			 && SKE.mixCounter < SKE.randomMix.length && 0 <= SKE.mixCounter
	  @			 && SKE.randomMix != null
	  @ 		 && SKE.counter < SKE.randoms.length-8 && 0 <= SKE.counter
	  @			 && SKE.randoms != null;
	  @ ensures ghost_key_left_0.ident == key_left0.ident &&
	  @         ghost_key_left_1.ident == key_left1.ident &&
	  @         ghost_key_right_0.ident == key_right0.ident &&
	  @         ghost_key_right_1.ident == key_right1.ident &&
	  @         ghost_key_out_0.ident == key_out0.ident &&
	  @         ghost_key_out_1.ident == key_out1.ident &&
	  @			SKE.mixCounter == \old(SKE.mixCounter) + 1 &&
	  @			SKE.counter == \old(SKE.counter) + 8;  
	  @ assignable SKE.counter;
	  */
	public GarbledXORGate(Key key_left0, Key key_left1, Key key_right0, Key key_right1, Key key_out0, Key key_out1) {
		//@ set initialMixPos = SKE.mixCounter;
		//@ set initialCounterPos = SKE.counter;
		
		int[] order = SKE.getRandomMix();		
		
		//@ set ghost_key_left_0 = key_left0;
		//@ set ghost_key_left_1 = key_left1;
		//@ set ghost_key_right_0 = key_right0;
		//@ set ghost_key_right_1 = key_right1;
		//@ set ghost_key_out_0 = key_out0;
		//@ set ghost_key_out_1 = key_out1;

		//@ set chipherindex0 = order[0];
		//@ set chipherindex1 = order[1];
		//@ set chipherindex2 = order[2];
		//@ set chipherindex3 = order[3];
		evaluation_table = new Cipher[4];
		evaluation_table[order[0]] = SKE.Encrypt(key_left0, SKE.Encrypt(key_right0, key_out0));
		evaluation_table[order[1]] = SKE.Encrypt(key_left0, SKE.Encrypt(key_right1, key_out1));
		evaluation_table[order[2]] = SKE.Encrypt(key_left1, SKE.Encrypt(key_right0, key_out1));
		evaluation_table[order[3]] = SKE.Encrypt(key_left1, SKE.Encrypt(key_right1, key_out0));		
	}
	
	
	/*@ public normal_behaviour
	  @ requires ((in0.ident == ghost_key_left_0.ident) || (in0.ident == ghost_key_left_1.ident)) &&
	  @			 ((in1.ident == ghost_key_right_0.ident) || (in1.ident == ghost_key_right_1.ident));
	  @ ensures (((in0.ident == ghost_key_left_0.ident) &&  (in1.ident == ghost_key_right_0.ident)) ==> (\result.ident == ghost_key_out_0.ident)) &&
	  @         (((in0.ident == ghost_key_left_0.ident) &&  (in1.ident == ghost_key_right_1.ident)) ==> (\result.ident == ghost_key_out_1.ident)) &&
	  @         (((in0.ident == ghost_key_left_1.ident) &&  (in1.ident == ghost_key_right_0.ident)) ==> (\result.ident == ghost_key_out_1.ident)) &&
	  @         (((in0.ident == ghost_key_left_1.ident) &&  (in1.ident == ghost_key_right_1.ident)) ==> (\result.ident == ghost_key_out_0.ident)) &&
	  @			\fresh(\result);
	  @ assignable \nothing;
	  */
	public Key evaluate(Key in0, Key in1) {
		
		/*@ ensures
	  	  @ this.evaluation_table[0] != null &&
		  @ this.evaluation_table[0].key != null &&
		  @ \typeof(this.evaluation_table[0].message) == Cipher &&
		  @ this.evaluation_table[0].message != null &&
		  @ ((Cipher)this.evaluation_table[0].message).key != null &&
		  @ ((Cipher)this.evaluation_table[0].message).message != null &&
		  @ \typeof(((Cipher)this.evaluation_table[0].message).message) == Key &&
		  @	this.evaluation_table[1] != null &&
		  @ this.evaluation_table[1].key != null &&
		  @ \typeof(this.evaluation_table[1].message) == Cipher &&
		  @ this.evaluation_table[1].message != null &&
		  @ ((Cipher)this.evaluation_table[1].message).key != null &&
		  @ ((Cipher)this.evaluation_table[1].message).message != null &&
		  @ \typeof(((Cipher)this.evaluation_table[1].message).message) == Key &&
		  @	this.evaluation_table[2] != null &&
		  @ this.evaluation_table[2].key != null &&
		  @ \typeof(this.evaluation_table[2].message) == Cipher &&
		  @ this.evaluation_table[2].message != null &&
		  @ ((Cipher)this.evaluation_table[2].message).key != null &&
		  @ ((Cipher)this.evaluation_table[2].message).message != null &&
		  @ \typeof(((Cipher)this.evaluation_table[2].message).message) == Key &&
		  @	this.evaluation_table[3] != null &&
		  @ this.evaluation_table[3].key != null &&
		  @ \typeof(this.evaluation_table[3].message) == Cipher &&
		  @ this.evaluation_table[3].message != null &&
		  @ ((Cipher)this.evaluation_table[3].message).key != null &&
		  @ ((Cipher)this.evaluation_table[3].message).message != null &&
		  @ \typeof(((Cipher)this.evaluation_table[3].message).message) == Key;
		  @ signals_only \nothing;
		  @ assignable \less_than_nothing;
		 */
		{
			int lemma;
		}
		
		// Loop manually unrolled to allow for an automated proof
		/*@ ensures \typeof(evaluation_table[0].message) == Cipher && 
		  @ 		\typeof(((Cipher)evaluation_table[0].message).message) == Key; 
		  	  @ signals_only \nothing;
		  	  @ assignable \less_than_nothing;*/
		{int lemma1;}
		Object temp_inner = SKE.Decrypt(in0, evaluation_table[0]);
		// set observableBranch[0] = temp_inner != null;
		if(temp_inner != null) {
			// set observableCiphers[0] = (Cipher)temp_inner;
			Cipher inner_cipher = (Cipher)temp_inner;
			/*@ ensures \typeof(inner_cipher.message) == Key; 
			  	  @ signals_only \nothing; 
			  	  @ assignable \less_than_nothing;*/{int lemma1_1;}
			{int lemma1_1;}
			Object output = SKE.Decrypt(in1, inner_cipher);
			// set observableBranch[1] = output != null;
			if(output != null) {
				// set observableKeys[0] = (Key)output;
				return (Key)output;
			}
		}
		
		/*@ ensures \typeof(evaluation_table[1].message) == Cipher && 
		  @ 		\typeof(((Cipher)evaluation_table[1].message).message) == Key; 
		  @ signals_only \nothing;
		  @ assignable \less_than_nothing;*/{int lemma2;}
		temp_inner = SKE.Decrypt(in0, evaluation_table[1]);
		// set observableBranch[2] = temp_inner != null;
		if(temp_inner != null) {
			// set observableCiphers[1] = (Cipher)temp_inner;
			Cipher inner_cipher = (Cipher)temp_inner;
			/*@ ensures \typeof(inner_cipher.message) == Key; 
			  	  @ signals_only \nothing; 
			  	  @ assignable \less_than_nothing;*/{int lemma2_1;}
			Object output = SKE.Decrypt(in1, inner_cipher);
			// set observableBranch[2] = output != null;
			if(output != null) {
				// set observableKeys[1] = (Key)output;
				return (Key)output;
			}
		}
		
		/*@ ensures \typeof(evaluation_table[2].message) == Cipher && 
		  @ 		\typeof(((Cipher)evaluation_table[2].message).message) == Key; 
		  	  @ signals_only \nothing; 
		  	  @ assignable \less_than_nothing;*/{int lemma3;}
		temp_inner = SKE.Decrypt(in0, evaluation_table[2]);

		if(temp_inner != null) {

			Cipher inner_cipher = (Cipher)temp_inner;
			/*@ ensures \typeof(inner_cipher.message) == Key; 
			  	  @ signals_only \nothing; 
			  	  @ assignable \less_than_nothing;*/{int lemma3_1;}
			Object output = SKE.Decrypt(in1, inner_cipher);

			if(output != null) {

				return (Key)output;
			}
		}
		
		/*@ ensures \typeof(evaluation_table[3].message) == Cipher && 
		  @ 		\typeof(((Cipher)evaluation_table[3].message).message) == Key; 
		  	  @ signals_only \nothing;
		  	  @ assignable \less_than_nothing;*/{int lemma4;}
		temp_inner = SKE.Decrypt(in0, evaluation_table[3]);

		if(temp_inner != null) {

			Cipher inner_cipher = (Cipher)temp_inner;
			/*@ ensures \typeof(inner_cipher.message) == Key; 
			  	  @ signals_only \nothing;
			  	  @ assignable \less_than_nothing;*/{int lemma4_1;}
			Object output = SKE.Decrypt(in1, inner_cipher);

			if(output != null) {

				return (Key)output;
			}
		}
		
		return null;
	}
}
