package edu.kit.iks.main.crypts;


public final class SKE {
	
	//@ public static ghost int counter;
	//@ public static nullable ghost int[] randoms;
	
	public static /*@ nullable */ int[][] randomMix;
	//@ public static ghost int mixCounter;
	
	// assumption. do not prove
	/*@ public normal_behaviour
	  @ requires 0 <= mixCounter && mixCounter < randomMix.length && randomMix!= null;
	  @ ensures \result != null && \result.length == 4 &&
	  @ (\result[0] == 0 || \result[0] == 1 || \result[0] == 2 || \result[0] == 3) &&  
	  @ (\result[1] == 0 || \result[1] == 1 || \result[1] == 2 || \result[1] == 3) &&
	  @ (\result[2] == 0 || \result[2] == 1 || \result[2] == 2 || \result[2] == 3) &&
	  @ (\result[3] == 0 || \result[3] == 1 || \result[3] == 2 || \result[3] == 3) &&
	  @ \result[0] != \result[1] && \result[0] != \result[2] && \result[0] != \result[2] &&
	  @ \result[1] != \result[2] && \result[1] != \result[3] && \result[2] != \result[3] &&
	  @ \result == randomMix[\old(mixCounter)] && \old(mixCounter) + 1 == counter;
	  @ assignable randomMix;
	 */
	public static int[] getRandomMix() {
		return null;
	}
	
	// assumption. Do not proof
	/*@ public normal_behaviour
	  @ requires counter < randoms.length && randoms != null && counter >= 0;
	  @ ensures \fresh(\result) &&
	  @		\old(counter) + 1 == counter &&
	  @		\result.ident == randoms[\old(counter)] &&
	  @		(\forall int i; 0 <= i && i < randoms.length && i != \old(counter);	\result.ident != randoms[i]);
	  @ assignable counter; 
	  */
	public static Key GenKey() {
		return new Key(0);
	}
	

	//this is a assumption!
	/*@ public normal_behaviour
	  @ requires counter < randoms.length && randoms != null && counter >= 0;
	  @ ensures \result.key != null && (\result.key == k) && (\result.key.ident == k.ident) && 
	  @			(\result.message == m) && \fresh(\result) && \typeof(\result)==Cipher &&
	  @			(\result.ident == randoms[counter]) &&
	  @			(\old(counter) + 1 == counter) &&
	  @			(\forall int i; 0 <= i && i < randoms.length && i != \old(counter); \result.ident != randoms[i]) &&
	  @			(\result.\inv); 
	  @ assignable counter;
	  */
	public static Cipher Encrypt(Key k, Object m) {
		return new Cipher(k, m);
	}
	
	//maybe use that as an assumption!
	// provable automatically
	/*@ public normal_behaviour
	  @ requires c.\inv;
	  @ ensures ((c.key.ident == key.ident) ==> ( \result != null &&
	  @					(((\typeof(c.message) == Cipher) && (\typeof(((Cipher)c.message).message) == Key)) ==> 
	  @							(\typeof(\result) == Cipher && 
	  @							((Cipher)\result).\inv &&
	  @							(\typeof(((Cipher)(\result)).message) == Key) &&
	  @							((Key)((Cipher)(\result)).message).\inv && 
	  @							(((Cipher)\result).ident == c.message.ident) &&
	  @							(((Key)(((Cipher)(\result)).message)).ident == ((Key)(((Cipher)c.message).message))))) &&
	  @					((\typeof(c.message) == Key) ==> 
	  @							(\typeof(\result) == Key &&
	  @							((Key)\result).\inv &&
	  @							(((Key)\result).ident == c.message.ident)))))	   									
	  @         && ((c.key.ident != key.ident) ==> (\result == null));
	  */	     
	public static /*@ nullable, pure */ Identifyable Decrypt(Key key,  Cipher c) {
		return c.decrypt(key);	
	}
}
